Attribute VB_Name = "modMain"
'===================================================
'==            Brascome Technologies              ==
'== Visit collective.freeservers.com/visbasic.htm ==
'===================================================

Option Explicit

Type Token
    name As String
    pos As D3DVECTOR
    yaw As Integer
    VertList(50) As D3DLVERTEX
    matObject As D3DMATRIX
End Type

Type Jewel
    JewelId As Integer
    yaw As Integer
    pos As D3DVECTOR
    matObject As D3DMATRIX
    enabled As Boolean
End Type

Type WallPart
    WlShape(7) As D3DLVERTEX
End Type

Type Wall
    x1 As Integer
    y1 As Integer
    x2 As Integer
    y2 As Integer
    r As Integer
    g As Integer
    b As Integer
    TexId As Integer
End Type

Enum MZ
    MzFloor = 0
    MzWall = 1
    MzStart = 2
    MzFinish = 3
    MzTreasure = 4
End Enum

'App Constants
Public Const ScreenWidth As Integer = 640
Public Const ScreenHeight As Integer = 480
Public Const ScreenDepth As Integer = 16
Public Const MoveMultiplier As Single = 0.25
Public Const RotateMultiplier As Single = 10
Public Const MazeMultiplier As Single = 5
Public Const pi = 3.14159                   'Constant to hold the value of pi
Public Const Rad = pi / 180              'multiply degrees by Rad to get angle in radians
Public Const RecSize As Integer = 40
Public Const LEFT_GAME As String = "LEFT"
Public VectorCircle(360) As D3DVECTOR

'DirectX
Public dx As DirectX7                    'Direct X
Public DD As DirectDraw7                 'Direct Draw
Public Primary As DirectDrawSurface7     'Primary surface
Public BackBuffer As DirectDrawSurface7  'Backbuffer
Public Direct3D As Direct3D7             'Direct 3D
Public Device As Direct3DDevice7         'Direct 3D Device
Public ZBuffer As DirectDrawSurface7     'Z-buffer
Public g_rcDest As RECT
Public g_rcSrc As RECT
'DirectSound will be created by DirectX
Public Ds As DirectSound
Public DsBuffer As DirectSoundBuffer
Public DsBuffer3D As DirectSound3DBuffer   'This does all the 3D calculations
Public DsPrimary As DirectSoundBuffer      'The primary sound buffer
Public DsListener As DirectSound3DListener 'This represents you.
'Although this says D3D at the beginning
'it is only used because it has all the right
'properties for us: X, Y, Z
Public SoundPos As D3DVECTOR
Const sndMultiplier = 10

'Geometry
Public BGShape(50) As D3DLVERTEX        ' This is a bad guy
Public SquareList(2) As D3DLVERTEX      'This is the Player
Public Landscape(3) As D3DLVERTEX       'This is the static square
Public gJewel(20) As D3DLVERTEX         'This is a Jewel

'Textures
Public BaseTexture As DirectDrawSurface7 'Holds the board texture
Public FaceTex As DirectDrawSurface7     'Holds the face texture
Public WallTex(3) As DirectDrawSurface7  'Holds wall textures
Public JewelTex As DirectDrawSurface7

'User Interface
Public KeyUp As Boolean                  'Used to check for key presses
Public KeyRight As Boolean               'True if key is pressed, false if its not
Public KeyDown As Boolean
Public KeyLeft As Boolean
Public Yup As Boolean
Public Ydown As Boolean
Public blTraceOn As Boolean
Public bRunning As Boolean               'Boolean to check if program is still running


Public ScenesDone As Integer             'Frame rate details...
Public LastCheck As Long
Public SceneStr As String

Public PlayerRotation As Integer         'Holds the angle you're facing

Public bBirdsEye As Integer
Public PixLine As Integer


'Game variables
Public Piece() As Token                 'This is an array of the players
Public Player As Integer
Public NumPlayers As Integer
Public LocalPlayer As Integer
Public dst As Single
Public Jewels() As Jewel
Public NumJewels As Integer
Public GameStarting As Boolean

'Colors for overhead view
Public clrWall As Long
Public clrBackground As Long
Public clrMarked As Long
Public clrStart As Long
Public clrFinish As Long
Public Walls() As Wall
Public NumWalls As Integer
Public MaxWalls As Integer
Public gWalls() As WallPart

Public bCollision As Boolean
Public ColObjs() As Byte
Public Start As D3DVECTOR
Public Finish As D3DVECTOR
Public MazeX As Integer
Public MazeZ As Integer
Public Score As Integer
Public Lives As Integer

Public TrcFile As Integer


Public Sub GenerateUnitCircle()
'This is the code discussed in the tutorial...
Dim i As Integer
Dim Theta As Double

For i = 0 To 360
    Theta = i * Rad
    VectorCircle(i).x = Cos(Theta)
    VectorCircle(i).y = Sin(Theta)
Next i
End Sub

Sub CreateVertices()
    Dim i As Integer
    Dim j As Integer
    Dim x1 As Single
    Dim z1 As Single
    Dim x2 As Single
    Dim z2 As Single
    Dim o As Single

    'This is the player
    Call dx.CreateD3DLVertex(-0.5, 0, -0.5, dx.CreateColorRGB(0, 0.25, 0), 1, 0, 0, SquareList(0))
    Call dx.CreateD3DLVertex(-0.5, 0, 0.5, dx.CreateColorRGB(0, 0.25, 0), 1, 0, 0, SquareList(1))
    Call dx.CreateD3DLVertex(0.5, 0, 0, dx.CreateColorRGB(0, 1, 0), 1, 0, 0, SquareList(2))
    
    'This is the landscape
    Call dx.CreateD3DLVertex(0, -10.1, MazeMultiplier * MazeZ, dx.CreateColorRGB(1, 1, 1), 1, 0, 0, Landscape(0))
    Call dx.CreateD3DLVertex(0, -10.1, 0, dx.CreateColorRGB(1, 1, 1), 1, 0, MazeZ, Landscape(2))
    Call dx.CreateD3DLVertex(MazeMultiplier * MazeX, -10.1, MazeMultiplier * MazeZ, dx.CreateColorRGB(1, 1, 1), 1, MazeX, 0, Landscape(1))
    Call dx.CreateD3DLVertex(MazeMultiplier * MazeX, -10.1, 0, dx.CreateColorRGB(1, 1, 1), 1, MazeX, MazeZ, Landscape(3))
    
    'This is a bad guy
    Call dx.CreateD3DLVertex(0, 0, 0, dx.CreateColorRGB(1, 1, 1), 1, 0, 0, BGShape(0))
    i = 1
    For o = 0 To 360 Step 36
        x1 = 0 * Cos(o * Rad)
        z1 = 0 * Sin(o * Rad)
        x2 = 2 * Cos(o * Rad)
        z2 = 2 * Sin(o * Rad)
        Call dx.CreateD3DLVertex(x1, 0, z1, dx.CreateColorRGB(1, 1, 1), 1, o / 360 + 0.5, 0, BGShape(i))
        Call dx.CreateD3DLVertex(x2, -3, z2, dx.CreateColorRGB(1, 1, 1), 1, o / 360 + 0.5, 0.5, BGShape(i + 1))
        i = i + 2
    Next
    For o = 0 To 360 Step 36
        x1 = 2 * Cos(o * Rad)
        z1 = 2 * Sin(o * Rad)
        x2 = 2.5 * Cos(o * Rad)
        z2 = 2.5 * Sin(o * Rad)
        Call dx.CreateD3DLVertex(x1, -3, z1, dx.CreateColorRGB(1, 1, 1), 1, o / 360 + 0.5, 0.5, BGShape(i))
        Call dx.CreateD3DLVertex(x2, -5, z2, dx.CreateColorRGB(1, 1, 1), 1, o / 360 + 0.5, 1, BGShape(i + 1))
        i = i + 2
    Next
    'This is a Jewel
    i = 1
    For o = 0 To 360 Step 90
        x1 = 0.1 * Cos(o * Rad)
        z1 = 0.1 * Sin(o * Rad)
        x2 = 2 * Cos(o * Rad)
        z2 = 2 * Sin(o * Rad)
        Call dx.CreateD3DLVertex(x1, 0, z1, dx.CreateColorRGB(1, 1, 1), 1, o / 360 + 0.5, 0, gJewel(i))
        Call dx.CreateD3DLVertex(x2, -3, z2, dx.CreateColorRGB(1, 1, 1), 1, o / 360 + 0.5, 0.5, gJewel(i + 1))
        i = i + 2
    Next
    For o = 0 To 360 Step 90
        x1 = 2 * Cos(o * Rad)
        z1 = 2 * Sin(o * Rad)
        x2 = 0.1 * Cos(o * Rad)
        z2 = 0.1 * Sin(o * Rad)
        Call dx.CreateD3DLVertex(x1, -3, z1, dx.CreateColorRGB(1, 1, 1), 1, o / 360 + 0.5, 0.5, gJewel(i))
        Call dx.CreateD3DLVertex(x2, -5, z2, dx.CreateColorRGB(1, 1, 1), 1, o / 360 + 0.5, 1, gJewel(i + 1))
        i = i + 2
    Next
    
    
    'Create Textures
    Set BaseTexture = CreateTextureSurface(App.Path & "\CarvedStone.bmp", 256, 256)
    Set FaceTex = CreateTextureSurface(App.Path & "\face.bmp", 256, 256)
    Set WallTex(0) = CreateTextureSurface(App.Path & "\thatch.bmp", 256, 256)
    Set WallTex(1) = CreateTextureSurface(App.Path & "\bricks.bmp", 256, 256)
    Set WallTex(2) = CreateTextureSurface(App.Path & "\sandstone.bmp", 256, 256)
    Set WallTex(3) = CreateTextureSurface(App.Path & "\spackle.bmp", 256, 256)
    Set JewelTex = CreateTextureSurface(App.Path & "\jewel.bmp", 256, 256)
    For i = 1 To NumPlayers
        If i = 1 Then
            Piece(i).pos.x = Start.x
            Piece(i).pos.z = Start.z
            Piece(i).pos.y = 10
        End If

        Piece(i).yaw = 0
        For j = 0 To 50
            Piece(i).VertList(j) = BGShape(j)
            Select Case i
            Case 1
                Piece(i).VertList(j).Color = dx.CreateColorRGB(1, 1, 1)
            Case 2
                Piece(i).VertList(j).Color = dx.CreateColorRGB(1, 0, 0)
            Case 3
                Piece(i).VertList(j).Color = dx.CreateColorRGB(1, 0, 1)
            Case 4
                Piece(i).VertList(j).Color = dx.CreateColorRGB(0, 0, 1)
            End Select
        Next
    Next
    
Dim Wclr As Long
Dim WallHeight As Single
Dim Ratio As Single

WallHeight = 10
'These are the walls
ReDim gWalls(NumWalls)
For i = 1 To NumWalls
    With Walls(i)
       ' Wclr = dx.CreateColorRGB(.r / 255, .g / 255, .b / 255)
        Wclr = dx.CreateColorRGB(1, 1, 1)
        Ratio = Sqr((.y1 - .y2) ^ 2 + (.x1 - .x2) ^ 2) / WallHeight
        If .x1 = .x2 Then
            Ratio = (Abs(.y1 - .y2) / WallHeight)
        Else
            Ratio = (Abs(.x1 - .x2) / WallHeight)
        End If
        'Front of wall
        Call dx.CreateD3DLVertex(.x1 * MazeMultiplier, 0, .y1 * MazeMultiplier, Wclr, 0, 0, 0, gWalls(i).WlShape(0))
        Call dx.CreateD3DLVertex(.x1 * MazeMultiplier, -WallHeight, .y1 * MazeMultiplier, Wclr, 0, 0, WallHeight / 5, gWalls(i).WlShape(1))
        Call dx.CreateD3DLVertex(.x2 * MazeMultiplier, 0, .y2 * MazeMultiplier, Wclr, 0, WallHeight * Ratio, 0, gWalls(i).WlShape(2))
        Call dx.CreateD3DLVertex(.x2 * MazeMultiplier, -WallHeight, .y2 * MazeMultiplier, Wclr, 0, WallHeight * Ratio, WallHeight / 5, gWalls(i).WlShape(3))
        'Back of wall
        Call dx.CreateD3DLVertex(.x2 * MazeMultiplier, 0, .y2 * MazeMultiplier, Wclr, 0, 0, 0, gWalls(i).WlShape(4))
        Call dx.CreateD3DLVertex(.x2 * MazeMultiplier, -WallHeight, .y2 * MazeMultiplier, Wclr, 0, 0, WallHeight / 5, gWalls(i).WlShape(5))
        Call dx.CreateD3DLVertex(.x1 * MazeMultiplier, 0, .y1 * MazeMultiplier, Wclr, 0, WallHeight * Ratio, 0, gWalls(i).WlShape(6))
        Call dx.CreateD3DLVertex(.x1 * MazeMultiplier, -WallHeight, .y1 * MazeMultiplier, Wclr, 0, WallHeight * Ratio, WallHeight / 5, gWalls(i).WlShape(7))
    End With
Next

End Sub
Public Sub AddPlayer(Plyr)
    Dim clr As Long
    Dim j As Integer
    
    Randomize Timer
    clr = dx.CreateColorRGB(Rnd(0), Rnd(0), Rnd(0))
    For j = 0 To 50
        Piece(Plyr).VertList(j) = BGShape(j)
        Select Case Plyr
        Case 1
            Piece(Plyr).VertList(j).Color = dx.CreateColorRGB(1, 1, 1)
        Case 2
            Piece(Plyr).VertList(j).Color = dx.CreateColorRGB(1, 0, 0)
        Case 3
            Piece(Plyr).VertList(j).Color = dx.CreateColorRGB(1, 0, 1)
        Case 4
            Piece(Plyr).VertList(j).Color = dx.CreateColorRGB(0, 0, 1)
        Case Else
            Piece(Plyr).VertList(j).Color = clr
        End Select
    Next
    
End Sub

'**************************************************************************************
'This is where our program starts
'**************************************************************************************
Public Sub Main()
    Dim strTrcFile As String
    
    clrWall = RGB(0, 0, 0)
    clrBackground = RGB(255, 255, 255)
    clrMarked = RGB(255, 0, 255)
    clrStart = RGB(0, 255, 0)
    clrFinish = RGB(255, 0, 0)
    
    blTraceOn = False
    If blTraceOn Then
        strTrcFile = App.Path & "\Trace\Trace" & format(Date, "yyyymmdd") & format(Time, "hhmmss") & ".trc"
        TrcFile = FreeFile
        Open strTrcFile For Output As TrcFile
    Else
        TrcFile = 0
    End If

    NumJewels = 50
    NumPlayers = 1
    Player = 1
    LocalPlayer = 1
    bBirdsEye = 2
    Lives = 3
    Score = 0
    bCollision = True
    GameStarting = True
    MultiChat.Show
    TrFile ("Load walls.bmp")
    Set MultiChat.pctTop.Picture = LoadPicture(App.Path & "\thinwalls.bmp")
    ReDim Piece(NumPlayers) As Token
    ReDim Jewels(NumJewels) As Jewel
    TrFile ("About to call AnalizeBoard")
    Call AnalizeBoard
'    Call Place_BadGuys

    TrFile ("About to call Initialize_DX")
    Call Initialize_DX(ScreenWidth, ScreenHeight, ScreenDepth)
    Call Place_Jewels
    Call GenerateUnitCircle
    Call CreateVertices
'    Call InitSound
    'Start the main loop
    bRunning = True
    Dim i As Integer
    For i = 1 To 10000
        DoEvents
    Next
    TrFile ("About to start main loop")
    Call Main_Loop
    
    'End the program and return to your normal life
    Call Endit
End Sub

'**************************************************************************************
'Call this sub to create a texture surface (surface to be used by D3D)
'ColKey is used for setting the colour key,
'0 = no colour key : 1 = Black colour key : 2 = Magneta (255,0,255) colour key
'
'Note.
'-----
'Texture surface dimensions must be to a power or 2 (^2)
'eg. possible sizes are :- 256x256, 128x128, 128,256, 16x16 etc...
'Its not advisable to use a surface bigger than 256x256 because not
'all cards support bigger surfaces than that.
'**************************************************************************************
Public Function CreateTextureSurface(sFile As String, pWidth As Long, pHeight As Long, Optional ColKey As Integer = 0) As DirectDrawSurface7

    Dim bOK As Boolean
    Dim enumTex As Direct3DEnumPixelFormats
    Dim sLoadFile As String
    Dim i As Long
    Dim ddsd As DDSURFACEDESC2
    Dim SurfaceObject As DirectDrawSurface7
    Dim Init As Boolean

    'Set our flags to tell the surface its a texture
    ddsd.lFlags = DDSD_CAPS Or DDSD_TEXTURESTAGE Or DDSD_PIXELFORMAT
    
    'If width and height were specified then make our texture that size,
    'otherwise it will be its normal size
    If ((pHeight <> 0) And (pWidth <> 0)) Then
        ddsd.lFlags = ddsd.lFlags Or DDSD_HEIGHT Or DDSD_WIDTH
        ddsd.lHeight = pHeight
        ddsd.lWidth = pWidth
    End If
    
    Set enumTex = Device.GetTextureFormatsEnum()

    'check if device supports 16bit surfaces
    For i = 1 To enumTex.GetCount()
        bOK = True
        Call enumTex.GetItem(i, ddsd.ddpfPixelFormat)

        With ddsd.ddpfPixelFormat
            If .lRGBBitCount <> 16 Then bOK = False
        End With
        If bOK = True Then Exit For
    Next

    If bOK = False Then
        Debug.Print "Unable to find 16bit surface support on your hardware - exiting"
        Init = False
    End If

    'set some texture surface flags
    If Device.GetDeviceGuid() = "IID_IDirect3DHALDevice" Then
            ddsd.ddsCaps.lCaps = DDSCAPS_TEXTURE
            ddsd.ddsCaps.lCaps2 = DDSCAPS2_TEXTUREMANAGE
            ddsd.lTextureStage = 0
    Else
            ddsd.ddsCaps.lCaps = DDSCAPS_TEXTURE
            ddsd.ddsCaps.lCaps2 = 0
            ddsd.lTextureStage = 0
    End If

    'If no filename was passed then create a blank surface
    If sFile = "" Then
        Set SurfaceObject = DD.CreateSurface(ddsd)
    Else
        Set SurfaceObject = DD.CreateSurfaceFromFile(sFile, ddsd)
    End If

    Set CreateTextureSurface = SurfaceObject

    'Colour key
    Dim ddckColourKey As DDCOLORKEY
    Dim ddpf As DDPIXELFORMAT
    
    'Make a Black colorkey
    If ColKey = 1 Then
        ddckColourKey.low = 0
        ddckColourKey.high = 0
        CreateTextureSurface.SetColorKey DDCKEY_SRCBLT, ddckColourKey
    
    'Make a Magneta Colorkey, rgb(255,0,255)
    ElseIf ColKey = 2 Then
        CreateTextureSurface.GetPixelFormat ddpf
        ddckColourKey.low = ddpf.lBBitMask + ddpf.lRBitMask
        ddckColourKey.high = ddckColourKey.low
        CreateTextureSurface.SetColorKey DDCKEY_SRCBLT, ddckColourKey
    End If
End Function



'**************************************************************************************
'The main game loop is in here
'**************************************************************************************
Public Sub Main_Loop()
    Dim vFrom As D3DVECTOR, vTo As D3DVECTOR, vUp As D3DVECTOR, matView As D3DMATRIX

    Dim mlngTimer As Long           '----}
    Dim mlngFrameTimer As Long      '    }  Used to calculate the Frames per second
    Dim mintFPSCounter As Integer   '----}
    Dim FPS As Integer              'Holds the number of frames per second

    Dim matWorld As D3DMATRIX   'Stores the world matrix, change this to move,
                                'scale and rotate objects.
    Dim matSquare As D3DMATRIX  'Holds matrix calculations
    Dim tmpMatSquare As D3DMATRIX 'Temporary matrix
    Dim j As Integer
    Dim intSide As Integer
    
    'Start our loop, press the 'Esc' key to exit
    Do Until bRunning = False
                
        'Check what keys are pressed, and move/scale the cube if neccesary
        Call Get_Keys
       ' Call Move_BadGuys
        
        'We use this matrix to stop the "landscape" moving...
        Call ScaleMatrix(matWorld, MakeVector(1, 1, 1))         'Scale matrix
        Call Device.SetTransform(D3DTRANSFORMSTATE_WORLD, matWorld)
        
        '#####################
        '## Make sound      ##
        '#####################
'        DsBuffer3D.SetPosition CubePosition.X / sndMultiplier, CubePosition.y / sndMultiplier, CubePosition.z / sndMultiplier, DS3D_IMMEDIATE
'
'        DsListener.SetPosition -4 / sndMultiplier, 4 / sndMultiplier, -4 / sndMultiplier, DS3D_IMMEDIATE
        
        '######################
        '## SETUP THE CAMERA ##
        '######################
        dx.IdentityMatrix matView
        Select Case bBirdsEye
            Case 0
                vTo.x = 0
                vTo.y = 0
                vTo.z = 0
                vFrom.x = -4
                vFrom.y = 4
                vFrom.z = -4
            Case 1
                vTo.x = 15.2
                vTo.y = 1
                vTo.z = 16.1
                vFrom.x = 15
                vFrom.y = 10
                vFrom.z = 15
            Case 2
                Player = 1
                With Piece(LocalPlayer)
                    vTo.x = .pos.x * MazeMultiplier + 1 * Cos(.yaw * Rad)
                    vTo.y = .pos.y
                    vTo.z = .pos.z * MazeMultiplier + 1 * Sin(.yaw * Rad)
                    vFrom.x = .pos.x * MazeMultiplier
                    vFrom.y = .pos.y
                    vFrom.z = .pos.z * MazeMultiplier
                End With
            Case 3
                Player = 2
                With Piece(2)
                    vTo.x = .pos.x * MazeMultiplier + 1 * Cos(.yaw * Rad)
                    vTo.y = .pos.y
                    vTo.z = .pos.z * MazeMultiplier + 1 * Sin(.yaw * Rad)
                    vFrom.x = .pos.x * MazeMultiplier
                    vFrom.y = .pos.y
                    vFrom.z = .pos.z * MazeMultiplier
                End With
            Case 4
                Player = 3
                With Piece(3)
                    vTo.x = .pos.x * MazeMultiplier + 1 * Cos(.yaw * Rad)
                    vTo.y = .pos.y
                    vTo.z = .pos.z * MazeMultiplier + 1 * Sin(.yaw * Rad)
                    vFrom.x = .pos.x * MazeMultiplier
                    vFrom.y = .pos.y
                    vFrom.z = .pos.z * MazeMultiplier
                End With
            Case 5
                Player = 4
                With Piece(4)
                    vTo.x = .pos.x * MazeMultiplier + 1 * Cos(.yaw * Rad)
                    vTo.y = .pos.y
                    vTo.z = .pos.z * MazeMultiplier + 1 * Sin(.yaw * Rad)
                    vFrom.x = .pos.x * MazeMultiplier
                    vFrom.y = .pos.y
                    vFrom.z = .pos.z * MazeMultiplier
                End With
        End Select
        vUp.x = 0: vUp.y = 1: vUp.z = 0
        Call dx.ViewMatrix(matView, vFrom, vTo, vUp, 0)
        Device.SetTransform D3DTRANSFORMSTATE_VIEW, matView
        
        '######################
        '## RENDER THE SCENE ##
        '######################
        Call Clear_Device
        Device.BeginScene
                    Dim i As Integer
                    Call Device.SetTexture(0, Nothing)
                    For i = 1 To NumWalls
                      '  Device.SetTextureStageState 0, D3DTSS_ADDRESS, D3DTADDRESS_WRAP
                        Call Device.SetTexture(0, WallTex(Walls(i).TexId))
                        Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, gWalls(i).WlShape(0), 8, D3DDP_DEFAULT
                    Next
                    
                    Call Device.SetTexture(0, BaseTexture)
                    Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, Landscape(0), 4, D3DDP_DEFAULT
                    
                    For i = 1 To NumPlayers
                        Call Device.SetTransform(D3DTRANSFORMSTATE_WORLD, Piece(i).matObject)
                        Call Device.SetTexture(0, FaceTex)
                        Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, Piece(i).VertList(0), 49, D3DDP_DEFAULT
                        If i <> LocalPlayer Then
                            Call DetectCollision(i)
                        End If
                    Next
                    
                    For i = 1 To NumJewels
                        If Jewels(i).enabled Then
                            With Jewels(i)
                                 .yaw = .yaw + 10
                                 If .yaw > 360 Then .yaw = 0
                                .matObject = SetMatrix(.pos, .yaw, 0, 0)
                                Call Device.SetTransform(D3DTRANSFORMSTATE_WORLD, .matObject)
                                Call Device.SetTexture(0, JewelTex)
                                Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, gJewel(0), 20, D3DDP_DEFAULT
                            End With
                        End If
                    Next
        Device.EndScene
        
        '###########################
        '## DRAW SOME INFORMATION ##
        '###########################
        PixLine = 0
        WriteLn ("Frame Rate: " & CStr(FPS) & " fps")
        For Player = 1 To NumPlayers
            With Piece(Player)
'            WriteLn ("Rotation: " & CStr(.yaw))
'            WriteLn ("Vector: " & CStr("[" & VectorCircle(PlayerRotation).x & "," & VectorCircle(PlayerRotation).y & "]"))
                WriteLn (.name & ": " & CStr(format(.pos.x, "00.0000")) & "," & CStr(format(.pos.y, "00.0000")) & "," & CStr(format(.pos.z, "00.0000")) & "Yaw " & CStr(format(.yaw, "000")))
'            WriteLn ("dist: " & format(dst, "00.0000"))
'            WriteLn ("Player: " & Player)
'            WriteLn ("Collision Byte: " & ColObjs(.pos.z, .pos.x))
            
            End With
        Next
'        Call DrawColBox
        '##############################
        '## CALCULATE THE FRAME RATE ##
        '##############################
        'Thanks to Lucky for this ;)
        mlngTimer = dx.TickCount()
        If dx.TickCount() - mlngFrameTimer >= 1000 Then
            mlngFrameTimer = dx.TickCount()
            FPS = mintFPSCounter
            mintFPSCounter = 0
        Else
            mintFPSCounter = mintFPSCounter + 1
        End If
        
        
        '####################
        '## FINISH UP LOOP ##
        '####################
        'Blit to the primary surface
        If bRunning Then
            dx.GetWindowRect MultiChat.pctCanvas.hWnd, g_rcDest
            j = Primary.Blt(g_rcDest, BackBuffer, g_rcSrc, DDBLT_WAIT)
            If j <> DD_OK Then
                MsgBox "Couldn't copy the source rectangle to the destination surface." & Chr$(13) & Hex(j)
                End
            End If
        End If
                
        'Let windows do its stuff
        DoEvents
    Loop
End Sub
Private Sub WriteLn(strLine As String)
    Call BackBuffer.SetForeColor(dx.CreateColorRGB(1, 1, 1))
    Call BackBuffer.DrawText(10, PixLine + 10, strLine, False)
    PixLine = PixLine + 15
End Sub
Private Sub DetectCollision(BGidx)
    Dim dst As Single
    Dim i As Integer
    dst = Sqr((Piece(BGidx).pos.x - Piece(LocalPlayer).pos.x) ^ 2 + (Piece(BGidx).pos.z - Piece(LocalPlayer).pos.z) ^ 2)
    If dst < 1 Then
        Lives = Lives - 1
        MultiChat.txtLives.Text = Lives
        If Lives = 0 Then
  '          Call EndGame
            
        End If
'        i = 1
'        Piece(i).pos.x = Start.x
'        Piece(i).pos.z = Start.z
'        Piece(i).pos.y = Start.y
'        Piece(i).yaw = 0
    End If
End Sub

Private Sub Move_BadGuys()
    Dim i As Integer
    Dim NewZ As Single
    Dim NewX As Single
    Dim bCol As Boolean
    Dim o As Integer
    Dim NewDir As Integer
    
    For i = 2 To 4
        bCol = False
        NewZ = Piece(i).pos.z + (VectorCircle(Piece(i).yaw).y * MoveMultiplier)
        If ColObjs(NewZ, Piece(i).pos.x) <> MZ.MzWall Then
            Piece(i).pos.z = NewZ
        Else
            bCol = True
        End If
    
        NewX = Piece(i).pos.x + (VectorCircle(Piece(i).yaw).x * MoveMultiplier)
        If ColObjs(Piece(i).pos.z, NewX) <> MZ.MzWall Then
            Piece(i).pos.x = NewX
        Else
            bCol = True
        End If
        
        'If we have collided with a wall and need to go in a diff direction
        If bCol = True Then
            NewDir = 4 * Rnd + 1
            For o = (NewDir * 90) To (NewDir * 90 + 360) Step 90
                NewZ = Piece(i).pos.z + (VectorCircle(o Mod 360).y * MoveMultiplier)
                NewX = Piece(i).pos.x + (VectorCircle(o Mod 360).x * MoveMultiplier)
                If ColObjs(NewZ, NewX) <> MZ.MzWall Then
                    Piece(i).yaw = o Mod 360
                End If
                DoEvents
            Next
        End If
        ' Piece(i).pos.y = Piece(i).pos.y + 1
        Piece(i).matObject = SetMatrix(Piece(i).pos, Piece(i).yaw, 0, 0)
    Next
End Sub
Public Sub PlacePlayer(Plyr)
    Dim x As Integer
    Dim z As Integer

    Randomize Timer

    Do While True
        DoEvents
        x = Int(MazeX * Rnd)
        z = Int(MazeZ * Rnd)
        If ColObjs(z, x) = MZ.MzFloor Then
            Piece(Plyr).pos.x = x
            Piece(Plyr).pos.y = -1
            Piece(Plyr).pos.z = z
            Piece(Plyr).yaw = Rnd * 360
            Exit Do
        End If
    Loop
    
End Sub
Private Sub Place_Jewels()
    Dim x As Integer
    Dim z As Integer
    Dim i As Integer
    Dim JewelId As Integer
    
    JewelId = 101
    For i = 1 To NumJewels
        Do While True
            DoEvents
            x = Int(MazeX * Rnd)
            z = Int(MazeZ * Rnd)
            If ColObjs(z, x) = MZ.MzFloor Then
                ColObjs(z, x) = JewelId
                With Jewels(i)
                     .pos.x = x
                     .pos.y = -1
                     .pos.z = z
                     .enabled = True
                     .JewelId = JewelId
                     .yaw = 0
                     .matObject = SetMatrix(.pos, .yaw, 0, 0)
                End With
                JewelId = JewelId + 1
                Exit Do
            End If
        Loop
    Next
    
    
End Sub
Private Sub DrawColBox()
    Dim y As Single
    Dim x As Single
    Dim i As Integer
    Dim strTemp As String
    
    For y = 0 To MazeZ
        For x = 0 To MultiChat.pctTop.ScaleWidth
            For i = 1 To 4
                If y = Int(Piece(i).pos.z) And x = Int(Piece(i).pos.x) Then
                    strTemp = strTemp & "x"
                Else
                    If i = 1 Then
                        strTemp = strTemp & ColObjs(y, x)
                    End If
                End If
            Next
            DoEvents
        Next
        strTemp = strTemp & vbCrLf
    Next
'    MultiChat.txtMap.Text = strTemp
End Sub
'**************************************************************************************
'This sub initializes DDraw and D3D
'It sets up a fullscreen, exclusive app. with a primary surface and a backbuffer
'**************************************************************************************
Public Sub Initialize_DX(Optional Width As Integer = 640, Optional Height As Integer = 480, Optional BPP As Byte = 16)
    Dim ddsd As DDSURFACEDESC2
    Dim caps As DDSCAPS2
    Dim DEnum As Direct3DEnumDevices
    Dim Guid As String
    
    ' Create the DirectDraw object and set the application
    ' cooperative level.
    Set dx = New DirectX7
    Set DD = dx.DirectDrawCreate("")
    
    'Make a fullscreen, exclusive application
    DD.SetCooperativeLevel MultiChat.pctCanvas.hWnd, DDSCL_NORMAL
'    DD.SetDisplayMode Width, Height, BPP, 0, DDSDM_DEFAULT
    
    
    ' Prepare and create the primary surface.
    ddsd.lFlags = DDSD_CAPS
    ddsd.ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE
    
    Set Primary = DD.CreateSurface(ddsd)
    
    ' Now create the render-target surface. We are reusing g_ddsd here.
    ' We specify system memory because we intend to use the
    ' RGB rasterizer.
    ddsd.lFlags = DDSD_HEIGHT Or DDSD_WIDTH Or DDSD_CAPS
    ddsd.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN Or DDSCAPS_3DDEVICE Or DDSCAPS_SYSTEMMEMORY
    
    
    ' Use the size of the form to determine the size of the render target
    ' and viewport rectangle.
    dx.GetWindowRect MultiChat.pctCanvas.hWnd, g_rcDest
    
    ' Set the dimensions of the surface description
    ddsd.lWidth = g_rcDest.Right - g_rcDest.Left
    ddsd.lHeight = g_rcDest.Bottom - g_rcDest.Top
    
    ' Create the render-target surface
    Set BackBuffer = DD.CreateSurface(ddsd)
    
    ' Cache the dimensions of the render target. We'll use
    ' it for blitting operations.
    With g_rcSrc
        .Left = 0: .Top = 0
        .Bottom = ddsd.lHeight
        .Right = ddsd.lWidth
    End With
    
    ' Create a DirectDrawClipper and attach it to the primary surface.
    Dim pcClipper As DirectDrawClipper
    
    Set pcClipper = DD.CreateClipper(0)
    pcClipper.SetHWnd MultiChat.pctCanvas.hWnd
    
    Primary.SetClipper pcClipper
    
    'Initialise Direct3D
    Call Init_D3D(Width, Height)
End Sub

'**************************************************************************************
'This sub initializes D3D
'**************************************************************************************
Public Sub Init_D3D(ScreenWidth As Integer, ScreenHeight As Integer)
    Dim DEnum As Direct3DEnumDevices
    Dim Guid As String
    
    'variables used for creating our Z-buffer
    Dim i As Integer
    Dim ZEnum As Direct3DEnumPixelFormats
    Dim pxf As DDPIXELFORMAT
    Dim ddsd2 As DDSURFACEDESC2
    
    
    Set Direct3D = DD.GetDirect3D
    
    'Get the last device driver (last one is usually the best one)
    'you could specify or search for a particular device, eg RGB or HAL device
    Set DEnum = Direct3D.GetDevicesEnum
'    Guid = DEnum.GetGuid(DEnum.GetCount)
    Guid = "IID_IDirect3DRGBDevice"
        
    
    '=================================================
    'This is where we will create our Z-Buffer
    'Create the z-buffer after creating the backbuffer
    'and before creating the Direct3D device.
    '=================================================
    Set ZEnum = Direct3D.GetEnumZBufferFormats(Guid)
    
    'Loop through until we find a Z-buffer that has a depth of at least 16-bits
    'you don't have to check the bitdepth, but for quality we'll go for 16-bit minimum
    For i = 1 To ZEnum.GetCount()
        Call ZEnum.GetItem(i, pxf)
        If pxf.lFlags = DDPF_ZBUFFER And pxf.lZBufferBitDepth >= 16 Then
            Exit For
        End If
    Next i
    
    'Prepare and create the z-buffer surface.
    ddsd2.lFlags = DDSD_CAPS Or DDSD_WIDTH Or DDSD_HEIGHT Or DDSD_PIXELFORMAT
    ddsd2.ddsCaps.lCaps = DDSCAPS_ZBUFFER
    ddsd2.lWidth = g_rcDest.Right - g_rcDest.Left
    ddsd2.lHeight = g_rcDest.Bottom - g_rcDest.Top
    ddsd2.ddpfPixelFormat = pxf
    
    'For hardware devices, the z-buffer should be in video memory. For software
    'devices, create the z-buffer in system memory.
    If Guid = "IID_IDirect3DRGBDevice" Then
        ddsd2.ddsCaps.lCaps = ddsd2.ddsCaps.lCaps Or DDSCAPS_SYSTEMMEMORY
    Else
        ddsd2.ddsCaps.lCaps = ddsd2.ddsCaps.lCaps Or DDSCAPS_VIDEOMEMORY
    End If
       
    'Create the Z-buffer surface
    Set ZBuffer = DD.CreateSurface(ddsd2)
    
    'Attach the Z-buffer to the backbuffer
    BackBuffer.AddAttachedSurface ZBuffer
    
    
    'Set the Device
    Set Device = Direct3D.CreateDevice(Guid, BackBuffer)
    
    'Define the viewport rectangle.
    'This will just be the same size as our screen
    Dim VPDesc As D3DVIEWPORT7
                
    VPDesc.lWidth = g_rcDest.Right - g_rcDest.Left
    VPDesc.lHeight = g_rcDest.Bottom - g_rcDest.Top
    VPDesc.lX = 0
    VPDesc.lY = 0
    VPDesc.minz = 0#
    VPDesc.maxz = 1#
    
    Device.SetViewport VPDesc
        

    'Set up transformation matrices.
    
    'The world matrix controls the position and orientation of the polygons
    'in world space.
    'By changing the world matrix you can rotate, move and scale objects.
    Dim matWorld As D3DMATRIX
    
    dx.IdentityMatrix matWorld
    Device.SetTransform D3DTRANSFORMSTATE_WORLD, matWorld
    
    
    'The projection matrix defines how the 3D scene is "projected" onto the
    '2D render target (the backbuffer surface).
    Dim matProj As D3DMATRIX
    
    'Polygons that are a closer distance than 1 to the camera,
    'and are a further distance than 100 will not be rendered.
    'We're using a 90 degree (pi/2) field of view (FOV).
    'Most people use either a 90 or 60 degree FOV for all applications
    Dim MaxDist As Integer
    MaxDist = Sqr((MazeZ * MazeMultiplier) ^ 2 + (MazeX * MazeMultiplier) ^ 2)
    Call dx.ProjectionMatrix(matProj, 1, MaxDist, pi / 2#)
    Device.SetTransform D3DTRANSFORMSTATE_PROJECTION, matProj
    
    
    'The view matrix defines the position, look at position, and roll of the camera.
    Dim matView As D3DMATRIX
    
    'We use the MakeVector function to define the positions of our camera,
    'Our camera is -20 units along the Z axis, and looking at the origin (0,0,0).
    'We'll leave the Up vector as (0,1,0) and the roll as 0.
    Call dx.ViewMatrix(matView, MakeVector(0, 0, -30), MakeVector(0, 0, 0), MakeVector(0, 1, 0), 0#)
    Device.SetTransform D3DTRANSFORMSTATE_VIEW, matView
    
    'Because we are using the LVertex type we don't want light to
    'have any effect on our scene, so we turn lighting off.
    Device.SetRenderState D3DRENDERSTATE_LIGHTING, False
    
    'Lets use Gouraud shading, it much nicer than Flat shading (D3DSHADE_FLAT)
    'DX7 does not support phong shading, so don't try to use it.
    Device.SetRenderState D3DRENDERSTATE_SHADEMODE, D3DSHADE_GOURAUD
    
    'Enable our Z-buffer
    Device.SetRenderState D3DRENDERSTATE_ZENABLE, D3DZB_TRUE
    
    'Lets use bilinear filtering, very cool
    'MAGFILTER is if the texture is stretched
    Device.SetTextureStageState 0, D3DTSS_MAGFILTER, D3DTFG_LINEAR
    'MINFILTER is if texture is made smaller
    Device.SetTextureStageState 0, D3DTSS_MINFILTER, D3DTFN_LINEAR
    
End Sub



'**************************************************************************************
'Call this function to make a vector
'**************************************************************************************
Public Function MakeVector(x As Single, y As Single, z As Single) As D3DVECTOR
    Dim v As D3DVECTOR
    v.x = x
    v.y = y
    v.z = z
    MakeVector = v
End Function



'**************************************************************************************
'TranslateMatrix, Call this to position an object at position specified by pVector
'**************************************************************************************
Public Sub TranslateMatrix(pMatrix As D3DMATRIX, pVector As D3DVECTOR)
  dx.IdentityMatrix pMatrix
  pMatrix.rc41 = pVector.x
  pMatrix.rc42 = pVector.y
  pMatrix.rc43 = pVector.z
End Sub

'**************************************************************************************
'ScaleMatrix, Call this to scale an object by values specified in pVector
'**************************************************************************************
Public Sub ScaleMatrix(pMatrix As D3DMATRIX, pVector As D3DVECTOR)
  dx.IdentityMatrix pMatrix
  pMatrix.rc11 = pVector.x
  pMatrix.rc22 = pVector.y
  pMatrix.rc33 = pVector.z
End Sub


Private Function GetTween(Min, Max, CurrentStep, TotalSteps) As Double
    GetTween = Min + (Max - Min) * CurrentStep / TotalSteps
End Function

Public Sub Get_Keys()
  '  Dim i As Integer
    Dim tmpMatSquare As D3DMATRIX
    Dim NewX As Single
    Dim NewZ As Single
    Dim i As Integer
    
    With Piece(LocalPlayer)
       ' MultiChat.pctDest.PSet (.pos.x, .pos.z), RGB(255, 255, 255)
        NewX = .pos.x
        NewZ = .pos.z
        If KeyLeft = True Then .yaw = .yaw + (1 * RotateMultiplier)
        If KeyRight = True Then .yaw = .yaw - (1 * RotateMultiplier)
        If .yaw < 0 Then .yaw = 360
        If .yaw > 360 Then .yaw = 0
    
        If KeyUp = True Then
            NewZ = .pos.z + (VectorCircle(.yaw).y * MoveMultiplier)
            If ColObjs(NewZ, .pos.x) <> MZ.MzWall Then
                 .pos.z = NewZ
            End If
        
            NewX = .pos.x + (VectorCircle(.yaw).x * MoveMultiplier)
            If ColObjs(.pos.z, NewX) <> MZ.MzWall Then
                 .pos.x = NewX
            End If
        End If
        If KeyDown = True Then
            NewX = .pos.x - (VectorCircle(.yaw).x * MoveMultiplier)
            If ColObjs(NewZ, NewX) <> MZ.MzWall Then
                 .pos.x = NewX
            End If
            NewZ = .pos.z - (VectorCircle(.yaw).y * MoveMultiplier)
            If ColObjs(NewZ, NewX) <> MZ.MzWall Then
                 .pos.z = NewZ
            End If
        End If
        
        'Player made it to the exit
        If ColObjs(.pos.z, .pos.x) = MZ.MzFinish Then
          '  Call EndGame
        End If
        
        'Player found a jewel
        If ColObjs(.pos.z, .pos.x) > 100 Then
            Score = Score + 1
            Jewels(ColObjs(.pos.z, .pos.x) - 100).enabled = False
            ColObjs(.pos.z, .pos.x) = MZ.MzFloor
            MultiChat.txtScore.Text = Score
        End If
        
        If Yup = True Then
             .pos.y = .pos.y + 1
        End If
        If Ydown = True Then
             .pos.y = .pos.y - 1
        End If
        
        If .pos.x < 0 Then .pos.x = 0
        If .pos.x > MazeX Then .pos.x = MazeX
        If .pos.z < 0 Then .pos.z = 0
        If .pos.z > MazeZ Then .pos.z = MazeZ
        
      '  MultiChat.pctDest.PSet (.pos.x, .pos.z), RGB(0, 0, 0)

    End With
    For i = 1 To NumPlayers
        With Piece(i)
            .matObject = SetMatrix(.pos, .yaw, 0, 0)
        End With
    Next

End Sub
Public Function SetMatrix(ObjVector As D3DVECTOR, yaw, pitch, roll) As D3DMATRIX
    Dim tmpMatrix As D3DMATRIX
    Dim RetVal As D3DMATRIX
    Dim tmpVect As D3DVECTOR
                    
    tmpVect.x = ObjVector.x * MazeMultiplier
    tmpVect.y = ObjVector.y
    tmpVect.z = ObjVector.z * MazeMultiplier
    
    dx.RotateXMatrix tmpMatrix, roll * Rad
    dx.RotateYMatrix RetVal, yaw * Rad
    dx.MatrixMultiply RetVal, RetVal, tmpMatrix
    dx.RotateZMatrix tmpMatrix, pitch * Rad
    dx.MatrixMultiply RetVal, RetVal, tmpMatrix
    Call TranslateMatrix(tmpMatrix, tmpVect)
    dx.MatrixMultiply RetVal, RetVal, tmpMatrix
    SetMatrix = RetVal
    
End Function


Public Sub Clear_Device()
    Dim ClearRect(0 To 0) As D3DRECT
    ClearRect(0).x2 = ScreenWidth
    ClearRect(0).y2 = ScreenHeight
    Device.Clear 1, ClearRect, D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, 0, 1, 0
End Sub


'**************************************************************************************
'Restore the display mode and return to normal life
'**************************************************************************************
Public Sub Endit()
    'Clean up DirectX
    Call DD.RestoreDisplayMode
    Call DD.SetCooperativeLevel(MultiChat.pctCanvas.hWnd, DDSCL_NORMAL)
    
    Set Device = Nothing
    Set Direct3D = Nothing
    Set ZBuffer = Nothing
    Set BackBuffer = Nothing
    Set Primary = Nothing
    Set DD = Nothing
    Set dx = Nothing
    
    'Kill sound objects
'    DsBuffer.Stop
'    Set DsBuffer = Nothing
'    Set DsBuffer3D = Nothing
'    Set Ds = Nothing
    
    Unload MultiChat
End Sub


Private Sub InitSound()
    Dim file As String
    
    On Local Error Resume Next
    Set Ds = dx.DirectSoundCreate("")
    
    'Tell the user we've got a problem
    If Err.Number <> 0 Then
        MsgBox "Unable to initialise; Either bad soundcard or bad drivers. Quiting"
        End
    End If



    'Priority gives us greater control.
    Ds.SetCooperativeLevel MultiChat.pctCanvas.hWnd, DSSCL_PRIORITY
    
    'These two describe what our sound buffer will be like
    Dim primDesc As DSBUFFERDESC, format As WAVEFORMATEX
    
    'Using the CTRL3D flag has speed penalties; dont use it unless
    'you have to - but you have to use it for 3D sounds...
    primDesc.lFlags = DSBCAPS_CTRL3D Or DSBCAPS_PRIMARYBUFFER
    'You can set the Stereo/Mono and Frequency settings here
    'and they will be applied to the primary buffer.
    Set DsPrimary = Ds.CreateSoundBuffer(primDesc, format)
    'Get a 3D listener device
    Set DsListener = DsPrimary.GetDirectSound3DListener()

    'The listener is at the 3D coordinate 0,0,0
    '+z is in front of you
    '-Z is behind you
    '-X is to your left
    '+x is to your right
    '+Y is above you
    '-Y is below you
    
    'We set the sound to be front-left
    'of the listener
    SoundPos.x = -0.5:  SoundPos.z = 0.5
    
    '0 is the loudest volume
    DsBuffer.SetVolume 0

    Dim bufferDesc1 As DSBUFFERDESC
    Dim waveFormat1 As WAVEFORMATEX
    
    file = App.Path & "\drip.wav"
    bufferDesc1.lFlags = (DSBCAPS_CTRL3D Or DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME) Or DSBCAPS_STATIC
    Set DsBuffer = Ds.CreateSoundBufferFromFile(file, bufferDesc1, waveFormat1)
    
    'The original buffer (above) must be created before this
    'line; and the original buffer must have the CTRL3D flag present
    Set DsBuffer3D = DsBuffer.GetDirectSound3DBuffer


    'The angles define how sensitive the sound buffer will be. A
    'narrower cone will result in more sensitive.
    'You can have 0 degrees for no cone
    'You can have 360 degrees for a full sphere
    'Or you can use any of these constants
    'DS3D_MINCONEANGLE
    'DS3D_MAXCONEANGLE
    'DS3D_DEFAULTCONEANGLE - the default is 360 degrees
    DsBuffer3D.SetConeAngles DS3D_MINCONEANGLE, 100, DS3D_IMMEDIATE
    'the DS3D_IMMEDIATE makes Directsound stop and recalculate ALL
    'Directsound3D Buffers, coordinates and positions. If you use
    'DS3D_DEFFERED flag, you can make several parameter changes before
    'allowing DirectSound to recalculate everything. You have to call;
    'DirectSound3DListener.CommitDefferedSettings before they take effect.
    DsBuffer3D.SetConeOutsideVolume -400, DS3D_IMMEDIATE
    
    
    DsBuffer3D.SetPosition SoundPos.x / 50, 0, SoundPos.z / 50, DS3D_IMMEDIATE
    
    'Keep the sound playing. As the sound
    'is a steady tone, looping it will make
    'it sound like a constant tone. With it being a
    'solid tone you can here the spacial positioning
    'very easily
    DsBuffer.Play DSBPLAY_LOOPING

End Sub



'Logic to find all walls
Public Sub AnalizeBoard()
    Dim x As Integer
    Dim z As Integer
    Dim pixl As Long
    Dim i As Integer

    TrFile ("Entered AnalizeBoard")
    MazeX = MultiChat.pctTop.ScaleWidth
    MazeZ = MultiChat.pctTop.ScaleHeight
    ReDim ColObjs(MazeX, MazeZ)
    MultiChat.ScaleMode = vbPixels
    MultiChat.pctTop.ScaleMode = vbPixels
    Start.x = 5
    Start.y = -3
    Start.z = 5
    MaxWalls = 20
    NumWalls = 0
    ReDim Walls(MaxWalls)
'    MultiChat.pctDest.ScaleMode = vbPixels
 '   MultiChat.pctDest.ScaleHeight = MultiChat.pctCanvas.ScaleHeight
 '   MultiChat.pctDest.ScaleWidth = MultiChat.pctCanvas.ScaleWidth
    'Initialize collision array
     For z = 0 To MazeZ
        For x = 0 To MazeX
            ColObjs(z, x) = MZ.MzFloor
        Next
    Next
    
    For z = 0 To MazeZ
        For x = 0 To MazeX
            pixl = MultiChat.pctTop.Point(x, z)
          '  MultiChat.pctTop.PSet (x, z), RGB(0, 0, 255)
          '  Debug.Print pixl
            If pixl = clrStart Then
                Start.x = x
                Start.y = -3
                Start.z = MazeZ - z
                ColObjs(MazeZ - z, x) = MZ.MzStart
            End If
            If pixl = clrFinish Then
                Finish.x = x
                Finish.y = -5
                Finish.z = MazeZ - z
                ColObjs(MazeZ - z, x) = MZ.MzFinish
            End If
            If pixl = clrWall Then
                ColObjs(MazeZ - z, x) = MZ.MzWall
                'We found a piece of the wall
                NumWalls = NumWalls + 1
                If NumWalls >= MaxWalls Then
                    MaxWalls = MaxWalls + 10
                    ReDim Preserve Walls(MaxWalls)
                End If
                Call MarkWall(x, z)
            End If
            DoEvents
            MultiChat.pctTop.PSet (x, z), pixl
        Next
    Next
    
    
    'Debug stuff
    TrFile ("About to create debug bmp")
    For i = 1 To NumWalls
        MultiChat.pctDest.Line (Walls(i).x1, Walls(i).y1)-(Walls(i).x2, Walls(i).y2), RGB(Walls(i).r, Walls(i).g, Walls(i).b)
        DoEvents
    Next
    TrFile ("Leaving AnalizeBoard")
End Sub

Public Sub MarkWall(OrigX, OrigY)
    Dim x As Integer
    Dim y As Integer
    Dim FoundNew As Boolean
    Dim Verticle As Boolean

    TrFile ("Entered MarkWall(" & OrigX & "," & OrigY & ")")
    x = OrigX
    y = OrigY
    
    If MultiChat.pctTop.Point(x - 1, y) = clrWall Then
        Verticle = False
    End If
    If MultiChat.pctTop.Point(x, y - 1) = clrWall Then
        Verticle = True
    End If

    'Find top left
    Do While True
        FoundNew = False
        If Verticle Then
            If MultiChat.pctTop.Point(x, y - 1) = clrWall Then
                y = y - 1
                FoundNew = True
            End If
        Else
            If MultiChat.pctTop.Point(x - 1, y) = clrWall Then
                x = x - 1
                FoundNew = True
            End If
        End If
        If FoundNew = False Then
            Exit Do
        End If
        ColObjs(MazeZ - y, x) = MZ.MzWall
        DoEvents
    Loop
    Walls(NumWalls).x1 = x
    Walls(NumWalls).y1 = MazeZ - y
    
    'Find Bottom Right
    Do While True
        FoundNew = False
        If Verticle Then
            If MultiChat.pctTop.Point(x, y + 1) = clrWall Then
                y = y + 1
                FoundNew = True
            End If
            'Make sure this isn't part of another wall
            If Not (MultiChat.pctTop.Point(x - 1, y) = clrWall Or MultiChat.pctTop.Point(x + 1, y) = clrWall) Then
                MultiChat.pctTop.PSet (x, y), clrMarked
            End If
        Else
            If MultiChat.pctTop.Point(x + 1, y) = clrWall Then
                x = x + 1
                FoundNew = True
            End If
            'Make sure this isn't part of another wall
            If Not (MultiChat.pctTop.Point(x, y - 1) = clrWall Or MultiChat.pctTop.Point(x, y + 1) = clrWall) Then
                MultiChat.pctTop.PSet (x, y), clrMarked
            End If
        End If
        ColObjs(MazeZ - y, x) = MZ.MzWall
        
        If FoundNew = False Then
            Exit Do
        End If
        DoEvents
    Loop
    Walls(NumWalls).x2 = x
    Walls(NumWalls).y2 = MazeZ - y
    Walls(NumWalls).r = Int(255 * Rnd)
    Walls(NumWalls).g = Int(255 * Rnd)
    Walls(NumWalls).b = Int(255 * Rnd)
    Walls(NumWalls).TexId = Int(4 * Rnd)
    TrFile ("Leaving MarkWall")
End Sub
Private Sub EndGame()
    If MsgBox("Would you like to play again?", vbYesNo, "Haunted Maze") = vbYes Then
        Lives = 3
        Score = 0
        MultiChat.txtLives.Text = Lives
        MultiChat.txtScore.Text = Score
'        Call Place_BadGuys
        Call Place_Jewels
    Else
        bRunning = False
        Unload MultiChat
    End If
End Sub
Public Sub TrFile(TrLine)
    On Error Resume Next
    If TrcFile > 0 Then
        Print #TrcFile, Now & ":" & TrLine
    End If
    Debug.Print Now & ":" & TrLine
    On Error GoTo 0
End Sub
